
// Writes contents of fifo to USB Keyboard one key by each other and wait the specified time after each character
// A character with value 0 means: no key but just wait
// Special Keys (variable special) mean: only set but no autorelease - there is a special Special Key´for that...
unsigned long writebuffer(int index) {
  mj_keybuffer k;
  unsigned long del;
  int i;
  int special;
  tasklist[index].active = true;
  if ( mj_fifo_stored() > 0 ) {
    k = mj_fifo_getelement();
    i = k.d & 0x0f;
    if ((k.d & 0x80) > 0) {
      special = 1;
    } else {
      special = 0;
    }
    if (i >= 0 && i <= 9) {
      del = mj_keydelay[i];
    } else {
      del = mj_keydelay[0];
    }
    if (special == 0) {
      if (k.c != KEY_NONE) {
        Keyboard.write(k.c);
      }
    } else {
      if (k.c != KEY_RELEASE) {
        Keyboard.press(k.c);
      } else {
        Keyboard.releaseAll();
      }
    }
    return (del);
  }
  return (5);
}

// Lock Windows Screen
void winlock() {
  // Left-Alt (\s83) + 'l' + release (\sff). \d1 and \d3 set the needed delay
  putfifo_string((char *) "\\d1\\s83l\\d3\\sff", 0);
}

// Shut down Windows the double \\ is interpreted by the c compiler and is only a single \ when being used over the serial console
void winshutdown() {
  putfifo_string((char *) "\\d1\\s83r\\d3\\sff\\d1cmd\\d3\n\\d1shutdown -s -t 10 -f\\d5\n\\d1\nexit\\d7\n", 0);
}

void winshutdown_alt() {
  putfifo_string((char *) "\\d1\\s82\\s80\\d5\\sd4\\sff\\d2\\s81\\sb3\\d5\\sff\\d2\n\\d3\\Xd9\\d7\\Xd9\n", 0);
  /*
    putfifosk(KEY_LEFT_ALT, DELAY_10);
    putfifosk(KEY_LEFT_CTRL, DELAY_10);
    putfifosk(KEY_DELETE, DELAY_10);
    putfifosk(KEY_RELEASE, DELAY_500);
    putfifosk(KEY_LEFT_SHIFT, DELAY_10);
    putfifosk(KEY_TAB, DELAY_10);
    putfifosk(KEY_RELEASE, DELAY_500);
    putfifo(KEY_RETURN, DELAY_10);
    putfifo(KEY_DOWN_ARROW, DELAY_100);
    putfifo(KEY_DOWN_ARROW, DELAY_100);
    putfifo(0, DELAY_1000);
    putfifo(KEY_RETURN, DELAY_500);
  */
}

void writekeypressed(int num, int shortlong) {
  Serial.print(F("Key"));
  Serial.print(num);
  Serial.print(F(" was Pressed "));
  Serial.print(shortlong ? "long" : "short");
  Serial.print(F("\n\r"));
}

unsigned long key1(int index) {
  static int laststate = HIGH;
  static long int triggerms = 0;
  int state;
  long int ms, now;
  tasklist[index].active = true;
  now = millis();
  state = digitalRead(mj_keypin[0]);
  if (state == LOW && laststate == HIGH) {
    triggerms = now;
  }
  if (state == HIGH && laststate == LOW && triggerms > 0) {
    ms = now - triggerms;
    if (ms < 1000 && ms > 10) {
      writekeypressed(1, 0);
      if (mj_jiggler_enable == 0) {
        mj_jiggler_enable = 1;
        mj_ledtiming_changed = true;
      } else {
        winlock();
      }
    } else if ( ms >= 1000 ) {
      writekeypressed(1, 1);
      mj_jiggler_enable = 0;
      mj_ledtiming_changed = true;
      winlock();
    }
  }
  if (state == HIGH) {
    triggerms = 0;
  }
  laststate = state;
  return (5);
}

unsigned long key2(int index) {
  static int laststate = HIGH;
  static long int triggerms = 0;
  int state;
  long int ms, now;
  tasklist[index].active = true;
  now = millis();
  state = digitalRead(mj_keypin[1]);
  if (state == LOW && laststate == HIGH) {
    triggerms = now;
  }
  if (state == HIGH && laststate == LOW && triggerms > 0) {
    ms = now - triggerms;
    if (ms < 1000 && ms > 10) {
      writekeypressed(2, 0);
      winshutdown();
    } else if ( ms >= 1000 ) {
      writekeypressed(2, 1);
      winshutdown_alt();
    }
  }
  if (state == HIGH) {
    triggerms = 0;
  }
  laststate = state;
  return (5);
}

unsigned long key3(int index) {
  static int laststate = HIGH;
  static long int triggerms = 0;
  int state;
  long int ms, now;
  tasklist[index].active = true;
  now = millis();
  state = digitalRead(mj_keypin[2]);
  if (state == LOW && laststate == HIGH) {
    triggerms = now;
  }
  if (state == HIGH && laststate == LOW && triggerms > 0) {
    ms = now - triggerms;
    if (ms < 1000 && ms > 10) {
      writekeypressed(3, 0);
      if (mj_jiggler_enable == 0) {
        mj_jiggler_enable = 1;
      } else {
        mj_jiggler_enable = 0;
      }
      mj_ledtiming_changed = true;
    } else if ( ms >= 1000 ) {
      writekeypressed(3, 1);
      putfifo_string((char *) "", 1);
    }
  }
  if (state == HIGH) {
    triggerms = 0;
  }
  laststate = state;
  return (5);
}

unsigned long key4(int index) {
  static int laststate = HIGH;
  static long int triggerms = 0;
  int state;
  long int ms, now;
  tasklist[index].active = true;
  now = millis();
  state = digitalRead(mj_keypin[3]);
  if (state == LOW && laststate == HIGH) {
    triggerms = now;
  }
  if (state == HIGH && laststate == LOW && triggerms > 0) {
    ms = now - triggerms;
    if (ms < 1000 && ms > 10) {
      writekeypressed(4, 0);
    } else if ( ms >= 1000 ) {
      writekeypressed(4, 1);
    }
  }
  if (state == HIGH) {
    triggerms = 0;
  }
  laststate = state;
  return (5);
}

unsigned long autotype(int index) {
  static int finished = false;
  static int initialized = false;
  if (initialized == false) {
    initialized = true;
    if (mj_autotype == true) {
      return (mj_autotype_delay);
    } else { // Disable task if no autotyping is used
      tasklist[index].active = false;
      tasklist[index].used = false;
      return (0);
    }
  }
  if (finished == false) {
    putfifo_string((char *) "", 1);
    finished = true;
    tasklist[index].active = false;
    tasklist[index].used = false;
  }
  return (0);
}

// Led Blinker
// mj_ledmode=0 statically blink
// mj_ledmode=1 heartbeat blink
// mj_ledmode=2 see 0 - but inverted timing jiggler enabled/disabled
// mj_ledmode=3 see 1 - but inverted timing jiggler enabled/disabled
// mj_ledmode=4 statically fade in/out
// mj_ledmode=5 heartbeat fade in/out
// mj_ledmode=6 see 4 - but inverted timing jiggler enabled/disabled
// mj_ledmode=7 see 5 - but inverted timing jiggler enabled/disabled
// mj_ledmode>7 see 5/7 (Bit 1 tells inverting jiggler enable/disable slowdown)
// mj_ledoption bit 0 = invert output led1
// mj_ledoption bit 1 = invert output led2

unsigned long led(int index) {
  static int state = 0;
  static unsigned long t[4] = {
    0, 0, 0, 0
  };
  static int value;
  int i = 0;
  unsigned int sleep = 500;
  tasklist[index].active = true;
  if (mj_ledtiming_changed == true) {
    // As this calculation uses division and multiplication we only calculate on change
    mj_ledtiming_changed = false;
    switch (mj_ledmode) {
      case 0:
      case 2:
        t[0] = (500 * (unsigned long) mj_ledtiming[0]) / 10000;
        t[1] = (500 * (unsigned long) mj_ledtiming[1]) / 10000;
        break;
      case 1:
      case 3:
        t[0] = (166 * (unsigned long) mj_ledtiming[0]) / 10000;
        t[1] = (166 * (unsigned long) mj_ledtiming[1]) / 10000;
        t[2] = (500 * (unsigned long) mj_ledtiming[2]) / 10000;
        break;
      case 4:
      case 6:
        t[0] = (31 * (unsigned long) mj_ledtiming[0]) / 10000;
        t[1] = (31 * (unsigned long) mj_ledtiming[1]) / 10000;
        t[2] = (500 * (unsigned long) mj_ledtiming[2]) / 10000;
        break;
      case 5:
      case 7:
      default:
        t[0] = (10 * (unsigned long) mj_ledtiming[0]) / 10000;
        t[1] = (10 * (unsigned long) mj_ledtiming[1]) / 10000;
        t[2] = (333 * (unsigned long) mj_ledtiming[2]) / 10000;
        break;
    }
    if ((mj_ledmode & 0x02) > 0) {
      i = !mj_jiggler_enable;
    } else {
      i = mj_jiggler_enable;
    }
    if (i == 0) {
      t[0] *= 3;
      t[1] *= 3;
      t[2] *= 3;
      t[3] *= 3;
    }
  }
  switch (mj_ledmode) {
    case 0:
    case 2:
      switch (state) {
        case 0:
          value = 255;
          sleep = t[0];
          state = 1;
          break;
        default:
          value = 0;
          sleep = t[1];
          state = 0;
          break;
      }
      break;
    case 1:
    case 3:
      switch (state) {
        case 0:
          value = 255;
          sleep = t[0];
          state = 1;
          break;
        case 1:
          value = 0;
          sleep = t[1];
          state = 2;
          break;
        case 2:
          value = 255;
          sleep = t[0];
          state = 3;
          break;
        default:
          value = 0;
          sleep = t[2];
          state = 0;
          break;
      }
      break;
    case 4:
    case 6:
      switch (state) {
        case 0:
          value += 16;
          sleep = t[0];
          if (value > 255) {
            value = 255;
            state = 1;
          }
          break;
        case 1:
          value -= 16;
          sleep = t[1];
          if (value < 0) {
            value = 0;
            state = 2;
          }
          break;
        case 2:
        default:
          sleep = t[2];
          state = 0;
          break;
      }
      break;
    case 5:
    case 7:
    default:
      switch (state) {
        case 0:
          value += 16;
          sleep = t[0];
          if (value > 255) {
            value = 255;
            state = 1;
          }
          break;
        case 1:
          value -= 16;
          sleep = t[1];
          if (value < 0) {
            value = 0;
            state = 2;
          }
          break;
        case 2:
          value += 16;
          sleep = t[0];
          if (value > 255) {
            value = 255;
            state = 3;
          }
          break;
        case 3:
          value -= 16;
          sleep = t[1];
          if (value < 0) {
            value = 0;
            state = 4;
          }
          break;
        default:
          sleep = t[2];
          state = 0;
          break;
      }
      break;
  }
  if ((mj_ledoption & 0x0001) == 0) {
    if (digitalPinHasPWM(mj_ledpin1) == true) {
      analogWrite(mj_ledpin1, value);
    } else {
      digitalWrite(mj_ledpin1, value > 127 ? 1 : 0);
    }
  } else {
    if (digitalPinHasPWM(mj_ledpin1) == true) {
      analogWrite(mj_ledpin1, 255 - value);
    } else {
      digitalWrite(mj_ledpin1, value > 127 ? 0 : 1);
    }
  }
  if ((mj_ledoption & 0x0002) == 0) {
    if (digitalPinHasPWM(mj_ledpin2) == true) {
      analogWrite(mj_ledpin2, value);
    } else {
      digitalWrite(mj_ledpin2, value > 127 ? 1 : 0);
    }
  } else {
    if (digitalPinHasPWM(mj_ledpin2) == true) {
      analogWrite(mj_ledpin2, 255 - value);
    } else {
      digitalWrite(mj_ledpin2, value > 127 ? 0 : 1);
    }
  }
  return (sleep);
}

unsigned long jiggler(int index) {
  unsigned long wait = 0;
  static int x, y, mx, my, state = 0;
  tasklist[index].active = true;
  switch (state) {
    case 0:
      if (mj_jiggler_enable == 1) {
        //random-generatre move, initial move
        x = random(0 - mj_jiggler_pixel, mj_jiggler_pixel);
        y = random(0 - mj_jiggler_pixel, mj_jiggler_pixel);
        mx = 0 - x;
        my = 0 - y;
        Mouse.move(x, y, 0);
        wait = random(50, 150);
        state = 1;
      } else {
        wait = 500;
      }
      break;
    case 1:
      // move backwards;
      Mouse.move(mx, my, 0);
      wait = random(50, 150);
      state = 2;
      break;
    case 2:
      // move backwards again;
      Mouse.move(mx, my, 0);
      wait = random(50, 150);
      state = 3;
      break;
    case 3:
      // move to original position;
      Mouse.move(x, y, 0);
      wait = random(mj_jiggler_min, mj_jiggler_max);
      state = 0;
      break;
    default:
      state = 0;
      break;
  }
  return (wait);
}

// Reads from Serial and writes into buffer. Calls parsestring() when \r or \n comes and deletes last char if 0x7f comes (Backspace)
unsigned long readser(int index) {
  unsigned char byte;
  static char buffer[SERIAL_BUFFERSIZE];
  static unsigned int numbytes = 0;
  int i = 10;
  tasklist[index].active = true;
  if (Serial.available() > 0) {
    i = 0;
    byte = (unsigned char) Serial.read();
    if (byte == '\n' || byte == '\r') {
      Serial.print(F("\n\r"));
      if (numbytes > 0) {
        buffer[numbytes] = '\0';
        parsestring(buffer, numbytes);
        numbytes = 0;
      }
    } else if (byte == 0x7f || byte == 0x08) {  // Del or Backspace
      if (numbytes > 0) {
        numbytes--;
        Serial.write(byte);
        Serial.write(' ');
        Serial.write(byte);
      }
    } else if (byte > 0x7f || byte < 0x20) { // Non-ASCII and non-printable will be ignored
      ;
    } else if (numbytes < (SERIAL_BUFFERSIZE - 1)) {
      buffer[numbytes] = byte;
      numbytes++;
      Serial.write(byte);
    }
  }
  return ((unsigned long) i);
}
